﻿using System.Text.Json.Serialization;
using RPG.GameCore.Enums;
using RPG.GameCore.Excel.Attributes;
using RPG.GameCore.Types;

namespace RPG.GameCore.Excel;

[ExcelTable("MainMissionExcelTable.json", ExcelType.MainMission)]
public class MainMissionRow : ExcelRow
{
    public override uint Id => MainMissionID;

    public uint MainMissionID { get; set; } // 0x10
    [JsonConverter(typeof(JsonStringEnumConverter))]
    public MainMissionType Type { get; set; } // 0x14
    public bool IsLoop { get; set; } // 0x18
    public uint[] NextMainMissionList { get; set; } = []; // 0x20
    public TextID Name { get; set; } // 0x28
    [JsonConverter(typeof(JsonStringEnumConverter))]
    public RequirementType TakeType { get; set; } // 0x2C
    public uint TakeParamInt1 { get; set; } // 0x30
    public uint[] TakeParamIntList { get; set; } = []; // 0x38
    [JsonConverter(typeof(JsonStringEnumConverter))]
    public RequirementType BeginType { get; set; } // 0x40
    public uint BeginParamInt1 { get; set; } // 0x44
    public TextID BeginDesc { get; set; } // 0x48
    public uint[] BeginParamIntList { get; set; } = []; // 0x50
    public uint[] StartSubMissionList { get; set; } = []; // 0x58
    public uint[] FinishSubMissionList { get; set; } = []; // 0x60
    public uint NextTrackMainMission { get; set; } // 0x68
    public uint TrackWeight { get; set; } // 0x6C
    public bool IsShowStartHint { get; set; } // 0x70
    public bool IsShowFinishHint { get; set; } // 0x71
    public uint RewardID { get; set; } // 0x74
    public uint DisplayRewardID { get; set; } // 0x78
}
