﻿using RPG.GameCore.Enums;
using RPG.GameCore.Excel.Attributes;
using RPG.GameCore.Types;
using System.Text.Json.Serialization;

namespace RPG.GameCore.Excel;

[ExcelTable("StageExcelTable.json", ExcelType.Stage)]
public class StageRow : ExcelRow
{
    public override uint Id => StageID;

    public uint StageID { get; set; } // 0x10
    [JsonConverter(typeof(JsonStringEnumConverter))]
    public StageType StageType { get; set; } // 0x14
    public TextID StageName { get; set; } // 0x18
    public uint HardLevelGroup { get; set; } // 0x1C
    public uint Level { get; set; } // 0x20
    public string LevelGraphPath { get; set; } = string.Empty; // 0x28
    public string[] StageAbilityConfig { get; set; } = []; // 0x30
    public StageMonsterWave[] MonsterList { get; set; } = []; // 0x48
    public string[] LevelLoseCondition { get; set; } = []; // 0x50
    public string[] LevelWinCondition { get; set; } = []; // 0x58
    public bool ForbidAutoBattle { get; set; } // 0x60
    public bool Release { get; set; } // 0x61
    public bool ForbidExitBattle { get; set; } // 0x62
}

public class StageMonsterWave
{
    public uint Monster0 { get; set; } // 0x10
    public uint Monster1 { get; set; } // 0x14
    public uint Monster2 { get; set; } // 0x18
    public uint Monster3 { get; set; } // 0x1C
    public uint Monster4 { get; set; } // 0x20
}