﻿using RPG.GameCore.Level.AI;
using RPG.GameCore.Level.Anim;
using RPG.GameCore.Level.Battle;
using RPG.GameCore.Level.Graph;
using RPG.GameCore.Level.Trigger;
using System.Text.Json.Serialization;

namespace RPG.GameCore.Level.Objects;

public class LevelMonsterInfo : NamedLevelObjectInfo
{
    public uint NPCMonsterID { get; set; } // 0x40
    public string LevelGraph { get; set; } = string.Empty; // 0x48
    public AIConfigInfo? AIConfig { get; set; } // 0x50
    public bool CreateOnInitial { get; set; } // 0x58
    public LevelGraphValueSource? ValueSource { get; set; } // 0x60
    public uint CampID { get; set; } // 0x68
    public BattleAreaReferenceInfo? BattleArea { get; set; } // 0x70
    public LevelTriggerInfo? Trigger { get; set; } // 0x78
    [JsonConverter(typeof(JsonStringEnumConverter))]
    public LevelAnimatingObjectState InitialAnimState { get; set; } // 0x80
    public uint RecordID { get; set; } // 0x84
    public uint EventID { get; set; } // 0x88
}
