﻿using RPG.Network.Proto;

namespace RPG.Services.Gameserver.Game.Entity;

internal class AvatarEntity : EntityBase
{
    public uint AvatarId { get; }
    public AvatarType AvatarType { get; }
    public uint Uid { get; }

    public AvatarEntity(uint id, uint avatarId, AvatarType type, uint uid) : base(id, 0, 0)
    {
        AvatarId = avatarId;
        AvatarType = type;
        Uid = uid;
    }

    public override EntityType Type => EntityType.EntityAvatar;

    public override SceneEntityInfo SceneEntityInfo
    {
        get
        {
            SceneEntityInfo info = base.SceneEntityInfo;
            info.Actor = new()
            {
                AvatarId = AvatarId,
                AvatarType = AvatarType,
                Uid = Uid
            };

            return info;
        }
    }
}
