﻿using RPG.GameCore.Level.Objects;
using RPG.Network.Proto;

namespace RPG.Services.Gameserver.Game.Entity;

internal class NpcEntity : EntityBase
{
    public uint NpcId { get; }

    public NpcEntity(uint id, uint groupId, uint instanceId, LevelNPCInfo info) : base(id, groupId, instanceId)
    {
        NpcId = info.NPCID;
    }

    public override EntityType Type => EntityType.EntityNpc;

    public override SceneEntityInfo SceneEntityInfo
    {
        get
        {
            SceneEntityInfo info = base.SceneEntityInfo;
            info.Npc = new()
            {
                NpcId = NpcId
            };

            return info;
        }
    }
}
