﻿using RPG.Network.Proto;

namespace RPG.Services.Gameserver.Game.Entity;

internal class NpcMonsterEntity : EntityBase
{
    public uint MonsterId { get; }
    public uint EventId { get; }

    public NpcMonsterEntity(uint id, uint groupId, uint instanceId, uint monsterId, uint eventId) : base(id, groupId, instanceId)
    {
        MonsterId = monsterId;
        EventId = eventId;
    }

    public override EntityType Type => EntityType.EntityMonster;

    public override SceneEntityInfo SceneEntityInfo
    {
        get
        {
            SceneEntityInfo info = base.SceneEntityInfo;
            info.NpcMonster = new()
            {
                MonsterId = MonsterId
            };

            return info;
        }
    }
}
