﻿using RPG.GameCore.Excel;
using RPG.GameCore.Level;
using RPG.Services.Core;

namespace RPG.Services.Gameserver;
internal class RPGGameserver : RPGServiceBase
{
    private readonly ExcelTables _excelTables;
    private readonly LevelTables _levelTables;

    public RPGGameserver(ServiceManager serviceManager, ExcelTables excelTables, LevelTables levelTables) : base(serviceManager)
    {
        _excelTables = excelTables;
        _levelTables = levelTables;
    }

    public override async Task StartAsync(CancellationToken cancellationToken)
    {
        _excelTables.Load();
        _levelTables.Load();
        await base.StartAsync(cancellationToken);
    }
}
